/*
 * Created by SharpDevelop.
 * User: demo
 * Date: 2/14/2010
 * Time: 12:57 AM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */

using System;
using WComp.Beans;
using WComp.EventedBeans;
using System.Runtime.InteropServices; //Thao added

namespace WComp.Beans
{
	/// <summary>
	/// Description of Bean1.
	/// This is a sample bean, which has an integer evented property.
	/// </summary>
	[Bean (Category="NguyenPhuongThao")]
	public class TicketChecker : EventedDrawable
	{
		/// <summary>
		/// Fill in private attributes here.
		/// </summary>
		
		//Thao added
		/// import DLL
		/// 
		[DllImport("../Lib/ConsoleApp.dll")]
		public extern static int GetValue(bool e_arrival);
		public int getValue(bool e_arrival)
		{
			MyProperty=GetValue(e_arrival);
			return (property);
		}
		//Thao - Addition ends
		private int property;
		/// <summary>
		/// This property will appear in bean's property panel and bean's input functions.
		/// </summary>
		public int MyProperty
		{
			get
			{
				return property;
			}
			set
			{
				property = value;
				FireIntEvent(property);		// event will be fired for every property set.
			}
		}

		/// <summary>
		/// Here are the delegate and his event.
		/// A function checking nullity should be used to fire events (like FireIntEvent).
		/// </summary>
		public delegate void IntValueEventHandler(int val);
		public event IntValueEventHandler PropertyChanged;
		
		private void FireIntEvent(int i){
			if (PropertyChanged != null)
			{
				PropertyChanged(i);
			}
		}
	}
}
